﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace WindowsFormsApplication1
{
    public partial class Finjmap : Form
    {
        public int forcus_r, forcus_a;
        public int maxval = 18000; // 値の最大

        Bitmap img = new Bitmap(640, 480);
        uint[,] map = new uint[16,25];
        
        // タイトルを変更
        public void settitle(string text)
        {
            this.Text = text;
        }

        // マップに値をセット
        public void setmap(int idx_r,int idx_a,uint val)
        {
            map[idx_r, idx_a] = val;
        }

        // マップを読む
        public uint readmap(int idx_r, int idx_a)
        {
            return map[idx_r, idx_a];
        }

        // グラフを描く
        public void draw1(uint idx_r1, uint idx_r2, uint idx_a1, uint idx_a2)
        {
            int gx, gy;// 原点
            int r, a;
            int step_x, step_y;
            int scale;
            float magni;   // 倍率
            scale = pictureBox1.Size.Height / 3;
            magni = (float)scale / (float)maxval;
            step_x = pictureBox1.Size.Width / (15 + 24);
            step_y = (pictureBox1.Size.Height - scale) / (15 + 24);
            //step_x = 640 / (15 + 24);
            //step_y = (480 - scale) / (15 + 24);
            gx = 16 * step_x;
            gy = (15 + 24) * step_y + scale;
            Graphics g = Graphics.FromImage(img);
            g.FillRectangle(Brushes.White, g.VisibleClipBounds);//白で塗りつぶす

            for (r = 15; r > -1; r--)
            {
                gx = gx - step_x;
                gy = gy - step_y;
                for (a = 0; a < 25; a++)
                {
                    int aa;
                    Pen p = new Pen(Color.Black, 1);
                    Pen pi = new Pen(Color.Black, 2);
                    if (a == 0) aa = 0; else aa = a - 1;
                    if ((r == idx_r1) || (r == idx_r2))
                    {
                        // インデックスの線
                        g.DrawLine(pi
                            , gx + aa * step_x, gy - aa * step_y - map[r, aa] * magni
                            , gx + a * step_x, gy - a * step_y - map[r, a] * magni);
                    }
                    else
                    {
                        // その他の線
                        g.DrawLine(p
                            , gx + aa * step_x, gy - aa * step_y - map[r, aa] * magni
                            , gx + a * step_x, gy - a * step_y - map[r, a] * magni);
                    }

                    if ((a == idx_a1) || (a == idx_a2))
                    {
                        // インデックスの線
                        if (r < 15) g.DrawLine(pi
                                , gx + (a + 1) * step_x, gy - a * step_y + step_y - map[r + 1, a] * magni
                                , gx + a * step_x, gy - a * step_y - map[r, a] * magni);
                    }
                    else
                    {
                        // その他の線
                        if (r < 15) g.DrawLine(p
                                , gx + (a + 1) * step_x, gy - a * step_y + step_y - map[r + 1, a] * magni
                                , gx + a * step_x, gy - a * step_y - map[r, a] * magni);
                    }

                    // カーソル
                    if ((a == forcus_a) && (r == forcus_r))
                    {
                        g.DrawRectangle(pi, gx + a * step_x - 2, gy - a * step_y - map[r, a] * magni - 2, 5, 5);
                        p.Dispose();
                    }
                    p.Dispose();
                    pi.Dispose();
                }
            }
            pictureBox1.Image = img;
            g.Dispose();
        }

        public void draw2(uint idx_r1, uint idx_r2, uint idx_a1, uint idx_a2)
        {
            int gx, gy;// 原点
            int r, a;
            int step_x, step_y;
            int scale;
            float magni;   // 倍率
            scale = pictureBox1.Size.Height / 3;
            magni = (float)scale / (float)maxval;
            step_x = pictureBox1.Size.Width / (15 + 24);
            step_y = (pictureBox1.Size.Height - scale) / (15 + 24);
            //step_x = 640 / (15 + 24);
            //step_y = (480 - scale) / (15 + 24);
            //gx = 16 * step_x;
            //gy = (15 + 24) * step_y + scale;
            gx = 0;
            gy = 16 * step_y + scale;
            Graphics g = Graphics.FromImage(img);
            g.FillRectangle(Brushes.White, g.VisibleClipBounds);//白で塗りつぶす

            for (r = 0; r < 16; r++)
            {
                gx = gx + step_x;
                gy = gy - step_y;
                for (a = 0; a < 25; a++)
                {
                    int aa;
                    Pen p = new Pen(Color.Black, 1);
                    Pen pi = new Pen(Color.Black, 2);
                    if (a == 0) aa = 0; else aa = a - 1;
                    if ((r == idx_r1) || (r == idx_r2))
                    {
                        // インデックスの線
                        g.DrawLine(pi
                            , gx + aa * step_x, gy + aa * step_y - map[r, aa] * magni
                            , gx + a * step_x, gy + a * step_y - map[r, a] * magni);
                    }
                    else
                    {
                        // その他の線
                        g.DrawLine(p
                            , gx + aa * step_x, gy + aa * step_y - map[r, aa] * magni
                            , gx + a * step_x, gy + a * step_y - map[r, a] * magni);
                    }

                    if ((a == idx_a1) || (a == idx_a2))
                    {
                        // インデックスの線
                        if (r < 15) g.DrawLine(pi
                                , gx + (a + 1) * step_x, gy + a * step_y - step_y - map[r + 1, a] * magni
                                , gx + a * step_x, gy + a * step_y - map[r, a] * magni);
                    }
                    else
                    {
                        // その他の線
                        if (r < 15) g.DrawLine(p
                                , gx + (a + 1) * step_x, gy + a * step_y - step_y - map[r + 1, a] * magni
                                , gx + a * step_x, gy + a * step_y - map[r, a] * magni);
                    }

                    // カーソル
                    if ((a == forcus_a) && (r == forcus_r))
                    {
                        g.DrawRectangle(pi, gx + a * step_x - 2, gy + a * step_y - map[r, a] * magni - 2, 5, 5);
                        p.Dispose();
                    }
                    p.Dispose();
                    pi.Dispose();
                }
            }
            pictureBox1.Image = img;
            g.Dispose();
        }

        public Finjmap()
        {
            InitializeComponent();

            draw1(0, 0, 0, 0);
        }

        // クローズボタンが押されたイベント
        private void Form2_FormClosing(object sender, FormClosingEventArgs e)
        {
            e.Cancel = true;    // 閉じずに
            this.Hide();    // 見えなくする
        }
    }
}
